orte/class/orte_bitmap.h File Reference.TH "orte/class/orte_bitmap.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/class/orte_bitmap.h \- See \fBompi_bitmap.h\fP for an explanation of why there is a split between OMPI and ORTE for this generic class. 
.SH SYNOPSIS
.br
.PP
\fC#include 'orte_config.h'\fP
.br
\fC#include <string.h>\fP
.br
\fC#include 'include/types.h'\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br

.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef orte_bitmap_t \fBorte_bitmap_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBOBJ_CLASS_DECLARATION\fP (orte_bitmap_t)"
.br
.ti -1c
.RI "OMPI_DECLSPEC int \fBorte_bitmap_resize\fP (orte_bitmap_t *bm, size_t bit)"
.br
.RI "\fISizes the bitmap to ensure it has at least the specified number of bits in it. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBorte_bitmap_set_bit\fP (orte_bitmap_t *bm, size_t bit)"
.br
.RI "\fISet a bit of the bitmap. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBorte_bitmap_clear_bit\fP (orte_bitmap_t *bm, size_t bit)"
.br
.RI "\fIClear/unset a bit of the bitmap. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBorte_bitmap_is_set_bit\fP (orte_bitmap_t *bm, size_t bit)"
.br
.RI "\fIFind out if a bit is set in the bitmap. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBorte_bitmap_find_and_set_first_unset_bit\fP (orte_bitmap_t *bm, size_t *position)"
.br
.RI "\fIFind the first clear bit in the bitmap and set it. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBorte_bitmap_clear_all_bits\fP (orte_bitmap_t *bm)"
.br
.RI "\fIClear all bits in the bitmap. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBorte_bitmap_set_all_bits\fP (orte_bitmap_t *bm)"
.br
.RI "\fISet all bits in the bitmap. \fP"
.ti -1c
.RI "static int \fBorte_bitmap_size\fP (orte_bitmap_t *bm)"
.br
.RI "\fIGives the current size (number of bits) in the bitmap. \fP"
.in -1c
.SH "Detailed Description"
.PP 
See \fBompi_bitmap.h\fP for an explanation of why there is a split between OMPI and ORTE for this generic class. 

A bitmap implementation. The bits start off with 0, so this bitmap has bits numbered as bit 0, bit 1, bit 2 and so on. This bitmap has auto-expansion capabilities, that is once the size is set during init, it can be automatically expanded by setting the bit beyond the current size. But note, this is allowed just when the bit is set -- so the valid functions are set_bit and find_and_set_bit. Other functions like clear, if passed a bit outside the initialized range will result in an error.
.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC int orte_bitmap_clear_all_bits (orte_bitmap_t * bm)"
.PP
Clear all bits in the bitmap. 
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
ORTE error code if bm is NULL 
.RE
.PP

.SS "OMPI_DECLSPEC int orte_bitmap_clear_bit (orte_bitmap_t * bm, size_t bit)"
.PP
Clear/unset a bit of the bitmap. 
.PP
If the bit is beyond the current size of the bitmap, an error is returned
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.br
\fIbit\fP The bit which is to be cleared (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
ORTE error code if the bit is out of range, else success 
.RE
.PP

.SS "OMPI_DECLSPEC int orte_bitmap_find_and_set_first_unset_bit (orte_bitmap_t * bm, size_t * position)"
.PP
Find the first clear bit in the bitmap and set it. 
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.br
\fIposition\fP Position of the first clear bit (OUT)
.RE
.PP
\fBReturns:\fP
.RS 4
err ORTE_SUCCESS on success 
.RE
.PP

.SS "OMPI_DECLSPEC int orte_bitmap_is_set_bit (orte_bitmap_t * bm, size_t bit)"
.PP
Find out if a bit is set in the bitmap. 
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.br
\fIbit\fP The bit which is to be checked (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
ORTE error code if the bit is out of range 1 if the bit is set 0 if the bit is not set 
.RE
.PP

.SS "OMPI_DECLSPEC int orte_bitmap_resize (orte_bitmap_t * bm, size_t bit)"
.PP
Sizes the bitmap to ensure it has at least the specified number of bits in it. 
.PP
If it already does, then nothing happens. However, if the bitmap is too small, then it is resized to accommodate the bit, with all bits in the new space 'cleared'
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.br
\fIbit\fP The bit that must be 'covered' by the bitmap (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
ORTE error code or success 
.RE
.PP

.SS "OMPI_DECLSPEC int orte_bitmap_set_all_bits (orte_bitmap_t * bm)"
.PP
Set all bits in the bitmap. 
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
ORTE error code if bm is NULL 
.RE
.PP

.SS "OMPI_DECLSPEC int orte_bitmap_set_bit (orte_bitmap_t * bm, size_t bit)"
.PP
Set a bit of the bitmap. 
.PP
If the bit asked for is beyond the current size of the bitmap, then the bitmap is extended to accomodate the bit
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.br
\fIbit\fP The bit which is to be set (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code or success 
.RE
.PP

.SS "static int orte_bitmap_size (orte_bitmap_t * bm)\fC [inline, static]\fP"
.PP
Gives the current size (number of bits) in the bitmap. 
.PP
This is the legal (accessible) number of bits
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
ORTE error code if bm is NULL 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
